#include <algorithm>

#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <string>
#include <vector>

using namespace std;

#define FORC(it, V) for(__typeof((V).begin()) it = (V).begin(); it != (V).end(); ++it)

const int MAX = 1010;

int n;

char grille[MAX][MAX];
char text[MAX][MAX];
char tmp[MAX][MAX];

int main(void)
{
  for( ;; ) {
    scanf( "%d", &n );
    if( n == 0 ) break;

    for( int i = 0; i < n; ++i )
      scanf( "%s", grille[i] );
    for( int i = 0; i < n; ++i )
      scanf( "%s", text[i] );

    for( int t = 0; t < 4; ++t ) {
      for( int i = 0; i < n; ++i )
	for( int j = 0; j < n; ++j )
	  if( grille[i][j] == 'O' )
	    putchar( text[i][j] );

      for( int i = 0; i < n; ++i )
	for( int j = 0; j < n; ++j )
	  tmp[j][n-1-i] = grille[i][j];

      for( int i = 0; i < n; ++i )
	for( int j = 0; j < n; ++j )
	  grille[i][j] = tmp[i][j];      
    }
    putchar( '\n' );
  }
  return 0;
}
